'' =================================================================================================
''
''   File....... jm_bq32000.spin
''   Purpose.... 
''   Author..... Jon "JonnyMac" McPhalen (aka Jon Williams)
''               Copyright (c) 2011 Jon McPhalen
''               -- see below for terms of use
''   E-mail..... jon@jonmcphalen.com
''   Started.... 
''   Updated.... 
''
'' =================================================================================================


con

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000                                          ' use 5MHz crystal
' _xinfreq = 6_250_000                                          ' use 6.25MHz crystal

  CLK_FREQ = ((_clkmode - xtal1) >> 6) * _xinfreq
  MS_001   = CLK_FREQ / 1_000
  US_001   = CLK_FREQ / 1_000_000
 

con

  RX1 = 31
  TX1 = 30
  SDA = 29
  SCL = 28


con

  BQ32K_WR = %1101_0000
  BQ32K_RD = %1101_0001


con

   #1, HOME, GOTOXY, #8, BKSP, TAB, LF, CLREOL, CLRDN, CR       ' PST formmatting control
  #14, GOTOX, GOTOY, CLS


obj

  i2c  : "jm_i2c_basic"     
  term : "fullduplexserial"


var


pub main | x, s, m, h

  i2c.init(SCL, SDA)

  term.start(RX1, TX1, %0000, 115_200)
  pause(1)

  term.str(string(CLS, "BQ32000 Test", CR, CR))

  x := -1
  
  repeat
    s := get_reg(0)
    if (s <> x)
      x := s
      
      m := get_reg(1)
      h := get_reg(2)

      term.tx(HOME)
      term.tx(LF)
      term.tx(LF)
      term.hex(h & $3F, 2)
      term.tx(":")
      term.hex(m, 2)
      term.tx(":")
      term.hex(s, 2)      

    
pub pause(ms) | t

'' Delay program ms milliseconds

  t := cnt - 1088                                               ' sync with system counter
  repeat (ms #> 0)                                              ' delay must be > 0
    waitcnt(t += MS_001)


pub get_reg(reg) : regval

  i2c.start
  i2c.write(BQ32K_WR)
  i2c.write(reg)
  i2c.start
  i2c.write(BQ32K_RD)
  regval := i2c.read(i2c#NAK)
  i2c.stop


pub put_reg(reg, value)

  i2c.start
  i2c.write(BQ32K_WR)
  i2c.write(reg)
  i2c.write(value)   
  i2c.stop   

  
dat

{{

  Terms of Use: MIT License

  Permission is hereby granted, free of charge, to any person obtaining a copy of this
  software and associated documentation files (the "Software"), to deal in the Software
  without restriction, including without limitation the rights to use, copy, modify,
  merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
  permit persons to whom the Software is furnished to do so, subject to the following
  conditions:

  The above copyright notice and this permission notice shall be included in all copies
  or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
  INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
  PARTICULAR PURPOSE AND NON-INFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
  HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
  OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

}}